Package groovy.lang

# Class GString

java.lang.Object
groovy.lang.GroovyObjectSupport
groovy.lang.GString

All Implemented Interfaces:
  `Buildable`, `GroovyObject`, `Writable`, `Serializable`, `CharSequence`, `Comparable`

Direct Known Subclasses:
  `GStringImpl`

public abstract class GString extends GroovyObjectSupport implements Comparable, CharSequence, Writable, Buildable, Serializable
Represents a String which contains embedded values such as "hello there ${user} how are you?" which can be evaluated lazily. Advanced users can iterate over the text and values to perform special processing, such as for performing SQL operations, the values can be substituted for ? and the actual value objects can be bound to a JDBC statement. The lovely name of this class was suggested by Jules Gosnell and was such a good idea, I couldn't resist :)

Author:
  James Strachan
See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final GString`
`EMPTY`
A GString containing a single empty String and no values.
`static final Object[]`
`EMPTY_OBJECT_ARRAY`
`static final String[]`
`EMPTY_STRING_ARRAY`

## Constructor Summary

Constructors
Constructor
Description
`GString(Object values)`
`GString(Object[] values)`

## Method Summary

Modifier and Type
Method
Description
`void`
`build(GroovyObject builder)`
`char`
`charAt(int index)`
`int`
`compareTo(Object that)`
`boolean`
`equals(GString that)`
`boolean`
`equals(Object that)`
`byte[]`
`getBytes()`
`byte[]`
`getBytes(String charset)`
`abstract String[]`
`getStrings()`
`Object`
`getValue(int idx)`
`int`
`getValueCount()`
`Object[]`
`getValues()`
`int`
`hashCode()`
`Object`
`invokeMethod(String name, Object args)`
Overloaded to implement duck typing for Strings so that any method that can't be evaluated on this object will be forwarded to the toString() object instead.
`int`
`length()`
`Pattern`
`negate()`
Turns a String into a regular expression pattern
`GString`
`plus(GString that)`
`GString`
`plus(String that)`
`CharSequence`
`subSequence(int start, int end)`
`String`
`toString()`
`Writer`
`writeTo(Writer out)`
Writes this object to the given writer.

### Methods inherited from class groovy.lang.GroovyObjectSupport

`getMetaClass, getProperty, setMetaClass, setProperty`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.lang.CharSequence

`chars, codePoints, isEmpty`

## Field Details

### EMPTY_STRING_ARRAY

public static final String[] EMPTY_STRING_ARRAY

### EMPTY_OBJECT_ARRAY

public static final Object[] EMPTY_OBJECT_ARRAY

### EMPTY

public static final GString EMPTY
A GString containing a single empty String and no values.

## Constructor Details

### GString

public GString(Object values)

### GString

public GString(Object[] values)

## Method Details

### getStrings

public abstract String[] getStrings()

### invokeMethod

public Object invokeMethod(String name, Object args)
Overloaded to implement duck typing for Strings so that any method that can't be evaluated on this object will be forwarded to the toString() object instead.

Specified by:
  `invokeMethod` in interface `GroovyObject`
Overrides:
  `invokeMethod` in class `GroovyObjectSupport`
Parameters:
  `name` - the name of the method to call
  `args` - the arguments to use for the method call
Returns:
  the result of invoking the method

### getValues

public Object[] getValues()

### plus

public GString plus(GString that)

### plus

public GString plus(String that)

### getValueCount

public int getValueCount()

### getValue

public Object getValue(int idx)

### toString

public String toString()

Specified by:
  `toString` in interface `CharSequence`
Overrides:
  `toString` in class `Object`

### writeTo

public Writer writeTo(Writer out) throws IOException
Description copied from interface: `Writable`
Writes this object to the given writer.

This is used to defer content creation until the point when it is streamed to the output destination. Oftentimes, content will be defined but not necessarily created (as is may be the case with a Closure definition.) In that case, the output is then 'deferred' to the point when it is serialized to the writer. This class may be used whenever an object should be responsible for creating its own textual representation, but creating the entire output as a single String would be inefficient (such as outputting a multi-gigabyte XML document.)

Specified by:
  `writeTo` in interface `Writable`
Parameters:
  `out` - the Writer to which this Writable should output its data.
Returns:
  the Writer that was passed
Throws:
  `IOException` - if an error occurred while outputting data to the writer

### build

public void build(GroovyObject builder)

Specified by:
  `build` in interface `Buildable`

### hashCode

public int hashCode()

Overrides:
  `hashCode` in class `Object`

### equals

public boolean equals(Object that)

Overrides:
  `equals` in class `Object`

### equals

public boolean equals(GString that)

### compareTo

public int compareTo(Object that)

Specified by:
  `compareTo` in interface `Comparable`

### charAt

public char charAt(int index)

Specified by:
  `charAt` in interface `CharSequence`

### length

public int length()

Specified by:
  `length` in interface `CharSequence`

### subSequence

public CharSequence subSequence(int start, int end)

Specified by:
  `subSequence` in interface `CharSequence`

### negate

public Pattern negate()
Turns a String into a regular expression pattern

Returns:
  the regular expression pattern

### getBytes

public byte[] getBytes()

### getBytes

public byte[] getBytes(String charset) throws UnsupportedEncodingException

Throws:
  `UnsupportedEncodingException`